/*
  Generation Olympia Engine - C++ Port
  Project Home: http://www.sourceforge.net/projects/qb2c/
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  $Id: fileinput.cpp,v 1.8 2004/11/08 14:17:36 b_lindeijer Exp $
*/

#include "fileinput.h"
#include "engineglobals.h"
#include "render.h"


void load_file_v1(char* rfile)
{
	FILE *fp;	
	int	c = 0, d, e, whitec = makecol(192, 192, 192);
	char tmp[100];

	
	BITMAP *temppcx;

	sprintf(mapfile, "data/maps/%s.dtl", rfile);
			
    fp = fopen(mapfile, "r");
    	
	fscanf(fp, "%d", &c);

	fscanf(fp, "%s", &tmp[0]);
	fscanf(fp, "%hd", &endplane);
	fscanf(fp, "%hd", &lastlight);
		
	fscanf(fp, "%s", &tmp);

	int lx, ly, rx, ry, w, h;

	h = 20;
	w = 256;
	lx = xcenter - w / 2;
	ly = ycenter - h / 2;
	rx = lx + w - 1;
	ry = ly + h - 1;

	//win (0, lx, ly, rx + 6, ry);	

	updscreen();
	int bluec = makecol(64, 255, 64);

	for (c = 0; c < max_planes; c++)
	{
		planeinfo[c].active = FALSE;
	}

	//drawing_mode(DRAW_MODE_TRANS, NULL, 0, 0); 
	win (0, lx-4, ly, rx + 10, ry + 20);
	
	
	for (c = 0; c <= endplane; c++)
	{		
		sprintf(tmp, "Loading...");
		textout(offscreen, font, tmp, lx + 2, ly + 2, whitec);
		rect (offscreen, lx, ly + 16, lx + w , ly + h + 16, whitec);
		rectfill (offscreen, lx + 2, ly + 16 + 2, lx + (w - 4) * (float)c / endplane, ly + h + 16 - 2, bluec);
		updscreen();

		fscanf(fp, "%d", &d);
		if (d == 1) planeinfo[c].active = TRUE;
		if (d == 0) planeinfo[c].active = FALSE;

		fscanf(fp, "%d", &d);
		if (d == 1) planeinfo[c].condensed = TRUE;
		if (d == 0) planeinfo[c].condensed = FALSE;

		fscanf(fp, "%f", &planeinfo[c].basex);
		fscanf(fp, "%f", &planeinfo[c].basey);
		fscanf(fp, "%f", &planeinfo[c].basez);

		fscanf(fp, "%f", &planeinfo[c].xrot);
		fscanf(fp, "%f", &planeinfo[c].yrot);
		fscanf(fp, "%f", &planeinfo[c].zrot);

		fscanf(fp, "%f", &planeinfo[c].endx);
		fscanf(fp, "%f", &planeinfo[c].endy);
		fscanf(fp, "%f", &planeinfo[c].endz);

		fscanf(fp, "%f", &planeinfo[c].height);

		fscanf(fp, "%f", &planeinfo[c].rbx);
		fscanf(fp, "%f", &planeinfo[c].rby);
		fscanf(fp, "%f", &planeinfo[c].rbz);

		fscanf(fp, "%hd", &planeinfo[c].rows);
		fscanf(fp, "%hd", &planeinfo[c].cols);
		fscanf(fp, "%hd", &planeinfo[c].lastpoint);
		fscanf(fp, "%hd", &planeinfo[c].lastpoly);
		fscanf(fp, "%hd", &planeinfo[c].npoints);
		fscanf(fp, "%hd", &planeinfo[c].npolies);

		if (planeinfo[c].active)
		{

			for (d = 0; d <= planeinfo[c].lastpoint; d++)
			{
				for (e = 0; e < 11; e++)
				{
					fscanf(fp, "%f", &planeinfo[c].pointinfo[d][e]);
				}
			}

			sprintf(tmp, "data/maps/shadowmap/i%s_%d.bmp", rfile, c);
			temppcx = load_bmp(tmp, pal);

			for (d = 0; d <= planeinfo[c].lastpoly; d++)
			{
				for (e = 0; e < 10; e++)
				{
					fscanf(fp, "%d", &planeinfo[c].polyinfo[d][e]);
				}
				for (e = 0; e < 6; e++)
				{
					fscanf(fp, "%d", &planeinfo[c].polyvtx[d][e]);
				}

				fscanf(fp, "%d", &e);
				if (e == 1)
				{				
					//sprintf(tmp, "data/maps/shadowmap2/i%s_%d_%d.bmp", rfile, c, d);
					//temppcx = load_bmp(tmp, pal);
					
					if (planeinfo[c].radiosity_setup[d] == 0) planeinfo[c].radiosity[d] = create_system_bitmap(16, 16);
					blit (temppcx, planeinfo[c].radiosity[d], d * 16, 0, 0, 0, 16, 16);

					planeinfo[c].radiosity_setup[d] = 2;
				}
			}
			destroy_bitmap(temppcx);

		}

		for (d = 0; d < lastlight; d++)
		{
			fscanf(fp, "%f", &lightinfo[d].strength);
			fscanf(fp, "%d", &lightinfo[d].lightr);
			fscanf(fp, "%d", &lightinfo[d].lightg);
			fscanf(fp, "%d", &lightinfo[d].lightb);
		}

	}

	fclose(fp);

	updscreen();

	/*int a;
	for (a = 0; a <= endplane; a++)
	{
		for (c = 0; c <= planeinfo[a].lastpoint; c++)
		{
			planeinfo[a].pointinfo[c][8] = 0;
		}
		for (c = 0; c <= planeinfo[a].lastpoly; c++)
		{
			planeinfo[a].polyinfo[c][7] = 0;
		}
	}*/

	set_trans_blender(0, 0, 0, 0);
	drawing_mode(DRAW_MODE_SOLID, NULL, 0, 0); 

}

void load_file_v2(char* rfile)
{
	FILE *fp;	
	int	c = 0, d, e, whitec = makecol(192, 192, 192);
	char tmp[100];

	
	//BITMAP *temppcx;

	sprintf(mapfile, "data/maps/%s.dtl", rfile);
			
    fp = fopen(mapfile, "r");
    	
	fscanf(fp, "%d", &c);

	fscanf(fp, "%s", &tmp);
	fscanf(fp, "%d", &endplane);
	fscanf(fp, "%d", &lastlight);
		
	fscanf(fp, "%s", &tmp);

	int lx, ly, rx, ry, w, h;

	h = 20;
	w = 256;
	lx = xcenter - w / 2;
	ly = ycenter - h / 2;
	rx = lx + w - 1;
	ry = ly + h - 1;

	//win (0, lx, ly, rx + 6, ry);	

	updscreen();
	int bluec = makecol(64, 255, 64);

	for (c = 0; c < max_planes; c++)
	{
		planeinfo[c].active = FALSE;
	}

	//drawing_mode(DRAW_MODE_TRANS, NULL, 0, 0); 
	win (0, lx-4, ly, rx + 10, ry + 20);

		
	
	for (c = 0; c <= endplane; c++)
	{		
		sprintf(tmp, "Loading...");
		textout(offscreen, font, tmp, lx + 2, ly + 2, whitec);
		rect (offscreen, lx, ly + 16, lx + w , ly + h + 16, whitec);
		rectfill (offscreen, lx + 2, ly + 16 + 2, lx + (w - 4) * (float)c / endplane, ly + h + 16 - 2, bluec);
		updscreen();

		fscanf(fp, "%d", &d);
		if (d == 1) planeinfo[c].active = TRUE;
		if (d == 0) planeinfo[c].active = FALSE;

		fscanf(fp, "%d", &d);
		if (d == 1) planeinfo[c].condensed = TRUE;
		if (d == 0) planeinfo[c].condensed = FALSE;

		fscanf(fp, "%f", &planeinfo[c].basex);
		fscanf(fp, "%f", &planeinfo[c].basey);
		fscanf(fp, "%f", &planeinfo[c].basez);

		fscanf(fp, "%f", &planeinfo[c].xrot);
		fscanf(fp, "%f", &planeinfo[c].yrot);
		fscanf(fp, "%f", &planeinfo[c].zrot);

		fscanf(fp, "%f", &planeinfo[c].endx);
		fscanf(fp, "%f", &planeinfo[c].endy);
		fscanf(fp, "%f", &planeinfo[c].endz);

		fscanf(fp, "%f", &planeinfo[c].height);

		fscanf(fp, "%f", &planeinfo[c].rbx);
		fscanf(fp, "%f", &planeinfo[c].rby);
		fscanf(fp, "%f", &planeinfo[c].rbz);

		fscanf(fp, "%d", &planeinfo[c].rows);
		fscanf(fp, "%d", &planeinfo[c].cols);
		fscanf(fp, "%d", &planeinfo[c].lastpoint);
		fscanf(fp, "%d", &planeinfo[c].lastpoly);
		fscanf(fp, "%d", &planeinfo[c].npoints);
		fscanf(fp, "%d", &planeinfo[c].npolies);

		//temppcx = create_system_bitmap(16, 16);

		if (planeinfo[c].active)
		{

			for (d = 0; d <= planeinfo[c].lastpoint; d++)
			{
				for (e = 0; e < 11; e++)
				{
					fscanf(fp, "%f", &planeinfo[c].pointinfo[d][e]);
				}
			}
			
						
			for (d = 0; d <= planeinfo[c].lastpoly; d++)
			{
				for (e = 0; e < 10; e++)
				{
					fscanf(fp, "%d", &planeinfo[c].polyinfo[d][e]);
				}
				for (e = 0; e < 6; e++)
				{
					fscanf(fp, "%d", &planeinfo[c].polyvtx[d][e]);
				}

				fscanf(fp, "%d", &e);
												
				if (e == 1)
				{				
					//sprintf(tmp, "data/maps/shadowmap2/i%s_%d_%d.bmp", rfile, c, d);
					//temppcx = load_bmp(tmp, pal);
					
					if (planeinfo[c].radiosity_setup[d] == 0) 
					{
						planeinfo[c].radiosity[d] = create_system_bitmap(16, 16);
						planeinfo[c].radiosity_setup[d] = 1;
						//rectfill (planeinfo[c].radiosity[d], 0, 0, 15, 15, -1);
						//blit(textures[planeinfo[c].polyinfo[d][3]], planeinfo[c].radiosity[d], 0, 0, 0, 0, 16, 16);
						
					}
					//rectfill (planeinfo[c].radiosity[d], 0, 0, 15, 15, 0);
					//blit (temppcx, planeinfo[c].radiosity[d], d * 16, 0, 0, 0, 16, 16);

					planeinfo[c].radiosity_setup[d] = 2;
				}
			}			

			//destroy_bitmap(temppcx);
			

		}

		

		
		for (d = 0; d < lastlight; d++)
		{
			fscanf(fp, "%f", &lightinfo[d].strength);
			fscanf(fp, "%d", &lightinfo[d].lightr);
			fscanf(fp, "%d", &lightinfo[d].lightg);
			fscanf(fp, "%d", &lightinfo[d].lightb);
		}

	}
	
	fclose(fp);
	

	updscreen();

	
	/*int a;
	for (a = 0; a <= endplane; a++)
	{
		for (c = 0; c <= planeinfo[a].lastpoint; c++)
		{
			planeinfo[a].pointinfo[c][8] = 0;
		}
		for (c = 0; c <= planeinfo[a].lastpoly; c++)
		{
			planeinfo[a].polyinfo[c][7] = 0;
		}
	}*/

	set_trans_blender(0, 0, 0, 0);
	drawing_mode(DRAW_MODE_SOLID, NULL, 0, 0); 	

}

void load_file_v1_simple(char* rfile)
{
	FILE *fp;
	char mapfile[100];
	int	c = 0, d, e;
	char tmp[100];

	BITMAP *temppcx;

	sprintf(mapfile, "data/maps/%s.smp", rfile);
			
    fp = fopen(mapfile, "r");
    	
	fscanf(fp, "%d", &c);

	fscanf(fp, "%s", &tmp);
	fscanf(fp, "%d", &endplane);
	fscanf(fp, "%d", &lastlight);
		
	fscanf(fp, "%s", &tmp);

	int lx, ly, rx, ry, w, h;

	h = ycenter / 5;
	w = xcenter / 2;
	lx = xcenter - w / 2;
	ly = ycenter - h / 2;
	rx = lx + w - 1;
	ry = ly + h - 1;

	win (0, lx, ly, rx + 6, ry);

	updscreen();
	int greenc = makecol(0, 255, 0);

	for (c = 0; c <= endplane; c++)
	{
		rectfill (screen, lx + 4, ly + 4, lx + 4 + (w - 8) * (float)c / endplane, ly + h - 4, greenc);
		fscanf(fp, "%d", &d);
		if (d == 1) planeinfo[c].active = TRUE;
		if (d == 0) planeinfo[c].active = FALSE;

		fscanf(fp, "%d", &d);
		if (d == 1) planeinfo[c].condensed = TRUE;
		if (d == 0) planeinfo[c].condensed = FALSE;

		if (planeinfo[c].active)
		{

			fscanf(fp, "%f", &planeinfo[c].basex);
			fscanf(fp, "%f", &planeinfo[c].basey);
			fscanf(fp, "%f", &planeinfo[c].basez);

			fscanf(fp, "%f", &planeinfo[c].xrot);
			fscanf(fp, "%f", &planeinfo[c].yrot);
			fscanf(fp, "%f", &planeinfo[c].zrot);

			fscanf(fp, "%f", &planeinfo[c].endx);
			fscanf(fp, "%f", &planeinfo[c].endy);
			fscanf(fp, "%f", &planeinfo[c].endz);

			fscanf(fp, "%f", &planeinfo[c].height);

			fscanf(fp, "%f", &planeinfo[c].rbx);
			fscanf(fp, "%f", &planeinfo[c].rby);
			fscanf(fp, "%f", &planeinfo[c].rbz);

			fscanf(fp, "%d", &planeinfo[c].rows);
			fscanf(fp, "%d", &planeinfo[c].cols);
			fscanf(fp, "%d", &planeinfo[c].lastpoint);
			fscanf(fp, "%d", &planeinfo[c].lastpoly);
			fscanf(fp, "%d", &planeinfo[c].npoints);
			fscanf(fp, "%d", &planeinfo[c].npolies);

			for (d = 0; d <= planeinfo[c].lastpoint; d++)
			{
				fscanf(fp, "%f", &planeinfo[c].pointinfo[d][7]);
				if (planeinfo[c].pointinfo[d][7] == 0)
				{
					for (e = 0; e < 11; e++)
					{
						fscanf(fp, "%f", &planeinfo[c].pointinfo[d][e]);
					}
				}
			}

			sprintf(tmp, "data/maps/shadowmap/i%s_%d.bmp", rfile, c);
			temppcx = load_bmp(tmp, pal);

			for (d = 0; d <= planeinfo[c].lastpoly; d++)
			{
				fscanf(fp, "%d", &planeinfo[c].polyinfo[d][6]);
				if (planeinfo[c].polyinfo[d][6] < 2)
				{
					for (e = 0; e < 10; e++)
					{
						fscanf(fp, "%d", &planeinfo[c].polyinfo[d][e]);
					}
					for (e = 0; e < 6; e++)
					{
						fscanf(fp, "%d", &planeinfo[c].polyvtx[d][e]);
					}

					fscanf(fp, "%d", &e);
					if (e == 1)
					{				
						//sprintf(tmp, "data/maps/shadowmap2/i%s_%d_%d.bmp", rfile, c, d);
						//temppcx = load_bmp(tmp, pal);
					
						if (planeinfo[c].radiosity_setup[d] == 0) planeinfo[c].radiosity[d] = create_system_bitmap(16, 16);
						blit (temppcx, planeinfo[c].radiosity[d], d * 16, 0, 0, 0, 16, 16);

						planeinfo[c].radiosity_setup[d] = 2;
					}
				}
			}
			destroy_bitmap(temppcx);

		}

		for (d = 0; d < lastlight; d++)
		{
			fscanf(fp, "%f", &lightinfo[d].strength);
			fscanf(fp, "%hd", &lightinfo[d].lightr);
			fscanf(fp, "%hd", &lightinfo[d].lightg);
			fscanf(fp, "%hd", &lightinfo[d].lightb);
		}

	}

	fclose(fp);

	updscreen();

}


