/*
  Generation Olympia Engine - C++ Port
  Project Home: http://www.sourceforge.net/projects/qb2c/
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  $Id: game.cpp,v 1.5 2004/11/08 14:17:36 b_lindeijer Exp $
*/

#include "../engine/fileinput.h"
#include "../engine/engineglobals.h"
#include "../engine/render.h"

#include "gamefileinput.h"
#include "gameglobals.h"
#include "game.h"

#include <math.h>

void calcsprites()
{
    short ind, sox, scx, scy;
    float nx, ny, nz, sx, sy, sz, ratio;

    nx = playerx - focusofs[0] -1 * cos(rad * (camry));
    ny = playery - focusofs[1];
    nz = playerz - focusofs[2] + 1 * sin(rad * (camry));
	
    sx = nx * prexx + ny * preyx + nz * prezx - camx;
    sz = nx * prexz + ny * preyz + nz * prezz - camz;

    sox = short(xcenter + sx / sz * xzoomratio);
        
	nx = playerx - focusofs[0];
    ny = playery - focusofs[1];
    nz = playerz - focusofs[2];

    sx = nx * prexx + ny * preyx + nz * prezx - camx;
    sy = nx * prexy + ny * preyy + nz * prezy - camy;
    sz = nx * prexz + ny * preyz + nz * prezz - camz;

    scx = short(xcenter + sx / sz * xzoomratio);
    scy = short(ycenter + sy / sz * yzoomratio - scrny);

    ratio = (float)abs(scx - sox) / 22;


    scx = scx - int(24 * ratio);
    scy = scy - int(46 * ratio);

    ind = -int(sz * 75) - 400;

    for(;;)
    {
        if (ind > vdist || ind < 0)
            break;

        if (dbuffer[ind] > 0)
            ind = ind + 1;
        if (dbuffer[ind] == 0)
        {
            dbuffer[ind] = 1;
            if (ind < start)
                start = ind;
            if (ind > depth)
                depth = ind;
            break;
        }
    }

    pscx = scx;
    pscy = scy;
    pratio = ratio;

    
}

void checkkbd()
{
    float ofs;

	ofs = .16 * fpsr;

	float ox = 0, oz = 0, p, clearance = 1;

	bool passx = TRUE, passy = TRUE, pass = TRUE;
	
	fill_surround();

	
	short	x, y;
	int whitec = makecol(255, 255, 255), direc = 0, c;

	view_updated = FALSE;


	
	for (c = 0; c < 8; c++)
	{
		if (joyinfo[c][1] != -1)
		{
			if ((joyinfo[c][2] == 1 && joy[0].stick[joyinfo[c][0]].axis[joyinfo[c][1]].d1) || (joyinfo[c][2] == 2 && joy[0].stick[joyinfo[c][0]].axis[joyinfo[c][1]].d2))			
			{
				if (c == 0) key[KEY_UP] = TRUE;
				if (c == 1) key[KEY_DOWN] = TRUE;
				if (c == 2) key[KEY_LEFT] = TRUE;
				if (c == 3) key[KEY_RIGHT] = TRUE;
				if (c == 4) key[KEY_F] = TRUE;
				if (c == 5) key[KEY_S] = TRUE;
				if (c == 6) key[KEY_T] = TRUE;
				if (c == 7) key[KEY_Q] = TRUE;
			}
		} else {
			if (joy[0].button[joyinfo[c][0]].b)
			{
				if (c == 0) key[KEY_UP] = TRUE;
				if (c == 1) key[KEY_DOWN] = TRUE;
				if (c == 2) key[KEY_LEFT] = TRUE;
				if (c == 3) key[KEY_RIGHT] = TRUE;
				if (c == 4) key[KEY_F] = TRUE;
				if (c == 5) key[KEY_S] = TRUE;
				if (c == 6) key[KEY_T] = TRUE;
				if (c == 7) key[KEY_Q] = TRUE;
			}
		}
	}	
	
	
	
	if (key[KEY_F1]) gui_setkeys();
	if (key[KEY_S] && freeze < timer)	
	{
		camrx = u(camrx - 3 * fpsr);
		calcsteps();
		setup_scene();
		view_updated = TRUE;

		freeze = timer + .0001 * fpsr;
	}
	if (key[KEY_F] && freeze < timer)	
	{
		camrx = u(camrx + 3 * fpsr);
		calcsteps();
		setup_scene();
		view_updated = TRUE;

		freeze = timer + .0001 * fpsr;
	}
	if (key[KEY_Q] && freeze < timer)	
	{
		camry = u(camry - 5 * fpsr);
		calcsteps();
		setup_scene();
		view_updated = TRUE;

		freeze = timer + .0001 * fpsr;
	}
	if (key[KEY_T] && freeze < timer)	
	{
		camry = u(camry + 5 * fpsr);
		calcsteps();
		setup_scene();
		view_updated = TRUE;
		
		freeze = timer + .0001 * fpsr;
	}

	
	if (key[KEY_UP]) 
	{
		ox -= cos(rad * (camry-90));
		oz += sin(rad * (camry-90));

		direc = 3;
		
	}
	//oz = -1;
    if (key[KEY_DOWN])
	{
		ox -= cos(rad * (camry+90));
		oz += sin(rad * (camry+90));

		direc = 2;
		
	}
	//oz = 1;
	
	if (oz != 0)
	{
		for (y = -ofs * clearance; y < ofs * clearance; y++)
		{
			p = getpixel(surroundbmp, 24 + ox * ofs * 8, 24 + oz * ofs * 8 + y);
			if (p == whitec) passy = FALSE;
		}
		if (!passy) oz = 0;
	}	

	if (key[KEY_LEFT])
	{
		ox -= cos(rad * (camry));
		oz += sin(rad * (camry));

		direc = 1;
	}
	//ox = -1;
    if (key[KEY_RIGHT])
	{
		ox -= cos(rad * (camry - 180));
		oz += sin(rad * (camry - 180));

		direc = 0;
	}
	//ox = 1;
	if (ox != 0)
	{
		for (x = -ofs * clearance; x <= ofs * clearance; x++)
		{
			p = getpixel(surroundbmp, 24 + ox * ofs * 8 + x, 24 + oz * ofs * 8);
			if (p == whitec) passx = FALSE;	
		}
		if (!passx) ox = 0;
	}

	if (ox != 0 && oz != 0)
	{
		for (x = -ofs * clearance; x <= ofs * clearance; x++)
		{
			for (y = -ofs * clearance; y < ofs * clearance; y++)
			{
				p = getpixel(surroundbmp, 24 + ox * ofs * 8 + x, 24 + oz * ofs * 8 + y);
				if (p == whitec) pass = FALSE;
			}	
		}
		if (!pass)
		{
			ox = 0;
			oz = 0;
		}
	}

	p = getpixel(surroundbmp, 24 + ox * ofs * 8, 24 + oz * ofs * 8);
	if (p < whitec)
	{
		p = float(p) / 256 - 2;
		if (p > -1.5 && p < 1.5)
		{
			playery += p;
			playerx += ox * ofs;
			playerz += oz * ofs;
			
		}
	
	}

	if (ox != 0 || oz != 0)
	{
		curframe += 2 * ofs;
		while (curframe > 6) { curframe -= 6; }

		/*if (oz < 0) walkdir = up;
		if (oz > 0) walkdir = down;
		if (ox < 0) walkdir = left;
		if (ox > 0) walkdir = right;*/

		if (direc == 3) walkdir = up;
		if (direc == 2) walkdir = down;
		if (direc == 1) walkdir = left;
		if (direc == 0) walkdir = right;

		curstatus = status_walking;
	} else {
		curstatus = status_standing;
		
		curframe += 1.5 * ofs;
		while (curframe > 6) { curframe -= 6; }		
	}
	

	fightfocus[0] = playerx;
	fightfocus[1] = playery;
	fightfocus[2] = playerz;

	if (key[KEY_C]) 
	{
		cleanup_scene();
		setup_scene();
	}
	//if (key[KEY_S]) save_file_simple("1");

	
}

void cleanup_scene()
{
	int a, c;	
	
	for (a = 0; a <= endplane; a++)
	{
		for (c = 0; c <= planeinfo[a].lastpoly; c++)
		{
			if (planeinfo[a].polyinfo[c][10] == 0) planeinfo[a].polyinfo[c][6] = 2;
		}
		for (c = 0; c <= planeinfo[a].lastpoint; c++)
		{
			if (planeinfo[a].pointinfo[c][11] == 0) planeinfo[a].pointinfo[c][7] = 1;
		}
	}
}

void drawhud()
{
	int whitec = makecol(192,192,192);

	//rectfill (offscreen, 0, 0, xres - 1, wideheight, 0);
	//rectfill (offscreen, 0, yres - wideheight, xres - 1, yres - 1, 0);
	
	char tmp[100];
	sprintf(tmp, "%f", pratio);

	textout(offscreen, font, tmp, 320, 10, whitec);

	//return;

	char fpstext[100];
	char vistext[100];
	//int whitec = makecol(192,192,192);

	sprintf(fpstext, "%d fps", FPS);
	sprintf(vistext, "%d/%d vis polys", vispolys, npolies);

	win(0, 5, 5, 11 + MAX(text_length(font, fpstext), text_length(font, vistext)), 37 + 16);
	
	text_mode(-1);
	textout(offscreen, font, fpstext, 10, 10, whitec);
	textout(offscreen, font, vistext, 10, 18, whitec);
	
	//char tmp[100];
	sprintf(tmp, "%d npoints", npoints);
	textout(offscreen, font, tmp, 10, 26, whitec);

	sprintf(tmp, "%f cycle", cycle);
	textout(offscreen, font, tmp, 10, 34, whitec);

}


void drawpolys()
{    
	int i, poly, p1, p2, p3, t, a;
	short u[3], v[3], level;
	int trans = makecol(255, 0, 255), ambientr, ambientg, ambientb;

	float visibility, xcyc = 0, ycyc;
    
    V3D_f v1, v2, v3;

    vispolys = 0;

	ambientr = getr(ambientc);
	ambientg = getg(ambientc);
	ambientb = getb(ambientc);

		
	for (i = depth; i >= start; i--)
    {
        if (dbuffer[i] == 0)
            continue;

        if (dbuffer[i] > 99)
        {
            poly = short(dbuffer[i] - 100);
    
            xcyc = 0;
			ycyc = 0;
			if (polyinfo[poly].trigger == 1)
			{
				xcyc = cycle;
				ycyc = cycle;
			}
			if (polyinfo[poly].trigger == 2) ycyc = -cycle * 7;
			
			p1 = polyinfo[poly].p1;
            p2 = polyinfo[poly].p2;
            p3 = polyinfo[poly].p3;
            t = polyinfo[poly].tx;
			for (a = 0; a < 3; a++)
			{
				u[a] = polyinfo[poly].u[a];
				v[a] = polyinfo[poly].v[a];
			}

            v1.x = pointinfo[p1].x;
            v1.y = pointinfo[p1].y;
			v1.z = pointinfo[p1].sz;
            v1.u = u[0] + xcyc;
            v1.v = v[0] + ycyc;
			v1.c = ambientc;

            v2.x = pointinfo[p2].x;
            v2.y = pointinfo[p2].y;
			v2.z = pointinfo[p2].sz;
            v2.u = u[1] + xcyc;
            v2.v = v[1] + ycyc;

            v3.x = pointinfo[p3].x;
            v3.y = pointinfo[p3].y;
			v3.z = pointinfo[p3].sz;
            v3.u = u[2] + xcyc;
            v3.v = v[2] + ycyc;
			visibility = ((pointinfo[p1].scale + pointinfo[p2].scale + pointinfo[p3].scale) / 3 - camz * zm) / vdist;
			visibility = 1 - sin(1.75 * visibility);

			if (visibility < 0) visibility = 0;
			if (visibility > 1) visibility = 1;
			
			level = planeinfo[polyinfo[poly].plane].polyinfo[polyinfo[poly].poly][8];
			if (level > 0)
			{
				set_trans_blender(255,255,255,int(255 * (float(100 - level) / 100)));
				triangle3d_f(offscreen, POLYTYPE_PTEX_MASK_TRANS, planeinfo[polyinfo[poly].plane].radiosity[polyinfo[poly].poly], &v1, &v2, &v3);
			} else {
				//set_trans_blender(255,255,255,255);
				//triangle3d_f(offscreen, POLYTYPE_FLAT, NULL, &v1, &v2, &v3);	
				//set_trans_blender(ambientr,ambientg,ambientb,255 * visibility);
				//triangle3d_f(offscreen, POLYTYPE_PTEX_MASK_TRANS, planeinfo[polyinfo[poly].plane].radiosity[polyinfo[poly].poly], &v1, &v2, &v3);	
				triangle3d_f(offscreen, POLYTYPE_PTEX_MASK, planeinfo[polyinfo[poly].plane].radiosity[polyinfo[poly].poly], &v1, &v2, &v3);	
			}

			planeinfo[polyinfo[poly].plane].polyinfo[polyinfo[poly].poly][10] = 1;
			planeinfo[pointinfo[p1].plane].pointinfo[pointinfo[p1].point][11] = 1;
			planeinfo[pointinfo[p2].plane].pointinfo[pointinfo[p2].point][11] = 1;
			planeinfo[pointinfo[p3].plane].pointinfo[pointinfo[p3].point][11] = 1;
			
				
			++vispolys;
        }

        if (dbuffer[i] > 1 && dbuffer[i] < 100)
        {
			drawsprite(dbuffer[i]-2);
            /*npc = short(dbuffer[i]) - 2;
  
            ratio = npcinfo[npc][5];
    
			// WARNING: The sprites array and cf have not been initialized at this point!
            stretch_sprite(offscreen, sprites[cf], int(npcinfo[npc][3]), int(npcinfo[npc][4]), int(32 * ratio), int(32 * ratio));
			*/
			
        }

        if (dbuffer[i] == 1)
        {
			drawsprite(-1);
        }
        dbuffer[i] = 0;
    }


}



void drawsprite(short spritenum)
{
	
	if (spritenum == -1) 
	{
		stretch_sprite(offscreen, frames[0][curstatus][walkdir][(short)curframe], pscx, pscy, int(48 * pratio), int(48 * pratio));
	}

}

void fill_surround()
{
	short	c, i, p1, p2, p3, minx, minz, maxx, maxz, sx, sz, p, g, whitec = makecol(255, 255, 255);
	float	x, y, z;

	V3D_f v1, v2, v3;

	clear_to_color(surroundbmp, whitec);
	clear(triggerbmp);	

	for (i = depth; i >= start; i--)
    {
        
        if (!(dbuffer[i] > 99)) continue;
        
		c = short(dbuffer[i] - 100);
    		
		p1 = polyinfo[c].p1;
		p2 = polyinfo[c].p2;
		p3 = polyinfo[c].p3;
		
		if (polyinfo[c].clipped) continue;

		x = float(pointinfo[p1].xx + pointinfo[p2].xx + pointinfo[p3].xx) / 3;			
		z = float(pointinfo[p1].zz + pointinfo[p2].zz + pointinfo[p3].zz) / 3;
		y = pointinfo[p1].yy;
		if (pointinfo[p2].yy > y) y = pointinfo[p2].yy;
		if (pointinfo[p3].yy > y) y = pointinfo[p3].yy;

		x -= playerx;
		y -= playery;
		z -= playerz;


		if (x > -2 && z > -2 && x < 2 && z < 2 && y > -2 && y < 2)
		{
			
			v1.x = float(pointinfo[p1].xx - playerx + 3) * 8;
            v1.y = float(pointinfo[p1].zz - playerz + 3) * 8;
            v1.c = (y + 2) * 256;

            v2.x = float(pointinfo[p2].xx - playerx + 3) * 8;
            v2.y = float(pointinfo[p2].zz - playerz + 3) * 8;
			
            v3.x = float(pointinfo[p3].xx - playerx + 3) * 8;
            v3.y = float(pointinfo[p3].zz - playerz + 3) * 8;
			
			
			
			clear(surroundcbmp);

				triangle3d_f(surroundcbmp, POLYTYPE_FLAT, NULL, &v1, &v2, &v3);							
			
				minx = 128;
				minz = 128;
				maxx = -1;
				maxz = -1;

				if (v1.x < minx) minx = v1.x;
				if (v1.x > maxx) maxx = v1.x;
				if (v1.y < minz) minz = v1.y;
				if (v1.y > maxz) maxz = v1.y;

				if (v2.x < minx) minx = v2.x;
				if (v2.x > maxx) maxx = v2.x;
				if (v2.y < minz) minz = v2.y;
				if (v2.y > maxz) maxz = v2.y;

				if (v3.x < minx) minx = v3.x;
				if (v3.x > maxx) maxx = v3.x;
				if (v3.y < minz) minz = v3.y;
				if (v3.y > maxz) maxz = v3.y;

			
				for (sx = minx; sx <= maxx; sx++)
				{				
					for (sz = minz; sz <= maxz; sz++)
					{					
						p = getpixel(surroundcbmp, sx, sz);					
						g = getpixel(surroundbmp, sx, sz);
						if (g == whitec) g = 0;
						if (p > 0 && g < p)
						{
							putpixel(surroundbmp, sx, sz, p);
							putpixel(triggerbmp, sx, sz, polyinfo[c].trigger);
						}					
					}
				}
			//}
		}
	}
}


void gameinit()
{

	BITMAP* temppcx;

	//temppcx = load_pcx("data/textureset/player.pcx", pal);
	//if (!temppcx) { printf("Error loading data/textureset/player.pcx!\n"); exit(1); }	
	
	int c, d;

	char tmp[100];

	ripplex = 0;
	ripplez = 3;
	rippleamp = .2;
	ripplefalloff = 20;
	ripplewash = (float)1 / 8;


		
	for (c = 0; c < 6; c++)
	{
		for (d = 0; d < 3; d++)
		{
			sprintf(tmp, "data/anim/walkd%d.bmp", c + 1);
			temppcx = load_bmp(tmp, pal);

			frames[0][d][down][c] = create_system_bitmap(40, 40);
			clear_to_color(frames[0][d][down][c], makecol(255, 0, 255));
			stretch_sprite(frames[0][d][down][c], temppcx, 0, 0, 40, 40);			
		
			sprintf(tmp, "data/anim/walku%d.bmp", c + 1);
			temppcx = load_bmp(tmp, pal);

			frames[0][d][up][c] = create_system_bitmap(40, 40);
			clear_to_color(frames[0][d][up][c], makecol(255, 0, 255));
			stretch_sprite(frames[0][d][up][c], temppcx, 0, 0, 40, 40);			

			sprintf(tmp, "data/anim/walkl%d.bmp", c + 1);
			temppcx = load_bmp(tmp, pal);

			frames[0][d][left][c] = create_system_bitmap(40, 40);
			clear_to_color(frames[0][d][left][c], makecol(255, 0, 255));
			stretch_sprite(frames[0][d][left][c], temppcx, 0, 0, 40, 40);

			sprintf(tmp, "data/anim/walkr%d.bmp", c + 1);
			temppcx = load_bmp(tmp, pal);

			frames[0][d][right][c] = create_system_bitmap(40, 40);
			clear_to_color(frames[0][d][right][c], makecol(255, 0, 255));
			stretch_sprite(frames[0][d][right][c], temppcx, 0, 0, 40, 40);
		}
			sprintf(tmp, "data/anim/standu%d.bmp", c + 1);
			temppcx = load_bmp(tmp, pal);

			frames[0][0][up][c] = create_system_bitmap(40, 40);
			clear_to_color(frames[0][0][up][c], makecol(255, 0, 255));
			stretch_sprite(frames[0][0][up][c], temppcx, 0, 0, 40, 40);

			sprintf(tmp, "data/anim/standd%d.bmp", c + 1);
			temppcx = load_bmp(tmp, pal);

			frames[0][0][down][c] = create_system_bitmap(40, 40);
			clear_to_color(frames[0][0][down][c], makecol(255, 0, 255));
			stretch_sprite(frames[0][0][down][c], temppcx, 0, 0, 40, 40);

			sprintf(tmp, "data/anim/standl%d.bmp", c + 1);
			temppcx = load_bmp(tmp, pal);

			frames[0][0][left][c] = create_system_bitmap(40, 40);
			clear_to_color(frames[0][0][left][c], makecol(255, 0, 255));
			stretch_sprite(frames[0][0][left][c], temppcx, 0, 0, 40, 40);

			sprintf(tmp, "data/anim/standr%d.bmp", c + 1);
			temppcx = load_bmp(tmp, pal);

			frames[0][0][right][c] = create_system_bitmap(40, 40);
			clear_to_color(frames[0][0][right][c], makecol(255, 0, 255));
			stretch_sprite(frames[0][0][right][c], temppcx, 0, 0, 40, 40);
	}

	//temppcx = load_pcx("data/textureset/player.pcx", pal);
	//blit(temppcx, temp2, 0, 96, 0, 0, 31, 31);

	surroundbmp = create_system_bitmap(128, 128);
	surroundcbmp = create_system_bitmap(128, 128);
	triggerbmp = create_system_bitmap(128, 128);

	ambientc = makecol(0, 0, 0);
	cycle = 0;

	wideheight = yres / 5;

	int voices, pass;
	voices = detect_digi_driver(DIGI_AUTODETECT);
	pass = install_sound(DIGI_AUTODETECT, NULL, NULL);

	sound = FALSE;
	if (voices > 0 && pass == 0) 
	{
		sound = TRUE;
		reserve_voices(16, 0);
		//bgmusic[0] = load_sample("data/music/syn9 - bodysnatcher.wav");
		//bgmusic[1] = load_sample("data/music/vamp2.wav");
		//bgmusic[2] = load_sample("data/music/vamp3.wav");
		nowplaying = 0;
		//play_sample(bgmusic[nowplaying], 255, 128, 1000, TRUE);
	}


	use_joy = FALSE;
	if (install_joystick(JOY_TYPE_AUTODETECT) == 0)
	{
		use_joy = TRUE;

		load_file_joypad();
	}

}

void gui_setkeys()
{
	if (!use_joy) return;

	int xc, yc, w, cur = 0, a, b, k = 8, c;
											//key / stick, axis, pos
	int whitec = makecol(192,192,192);

	w = 192;
		
	xc = xcenter - w/2;

	char tmp[100];

	
	do
	{

		yc = ycenter - 64;

		win(0,xc, yc, xc + 256, yc + 16);
		sprintf(tmp, "Joystick Key Set [ESC-QUIT]");
		textout(offscreen, font, tmp, xc + 4, yc + 4, whitec);	
		

		for (a = 0; a < k; a++)
		{
			yc += 16;
			win(0,xc + 64, yc, xc + 192, yc + 16);
			if (cur == a) win(1,xc + 64, yc, xc + 192, yc + 16);			
		}

		yc = ycenter - 64;

		yc += 16;
		sprintf(tmp, "UP");
		textout(offscreen, font, tmp, xc + 64 + 4, yc + 4, whitec);	

		yc += 16;
		sprintf(tmp, "DOWN");
		textout(offscreen, font, tmp, xc + 64 + 4, yc + 4, whitec);	

		yc += 16;
		sprintf(tmp, "LEFT");
		textout(offscreen, font, tmp, xc + 64 + 4, yc + 4, whitec);	

		yc += 16;
		sprintf(tmp, "RIGHT");
		textout(offscreen, font, tmp, xc + 64 + 4, yc + 4, whitec);	

		yc += 16;
		sprintf(tmp, "ROTATE FWD");
		textout(offscreen, font, tmp, xc + 64 + 4, yc + 4, whitec);	
	
		yc += 16;
		sprintf(tmp, "ROTATE BACK");
		textout(offscreen, font, tmp, xc + 64 + 4, yc + 4, whitec);	

		yc += 16;
		sprintf(tmp, "ROTATE LEFT");
		textout(offscreen, font, tmp, xc + 64 + 4, yc + 4, whitec);

		yc += 16;
		sprintf(tmp, "ROTATE RIGHT");
		textout(offscreen, font, tmp, xc + 64 + 4, yc + 4, whitec);


		poll_keyboard();
		poll_joystick();

		c = cur;
		if (freeze < timer)
		{
			for (a = 0; a < joy[0].num_sticks; a++)
			{
				
				for (b = 0; b < joy[0].stick[a].num_axis; b++)
				{
					if (joy[0].stick[a].axis[b].d1 && joy[0].stick[a].axis[b].pos != 0)
					{
						joyinfo[cur][0] = a;
						joyinfo[cur][1] = b;
						joyinfo[cur][2] = 1;
						
						//allegro_message("stick %d, axis %d\n%s\npos %d", a, b, joy[0].stick[a].axis[b].name, joy[0].stick[a].axis[b].pos);
						cur++;					
						freeze = timer + .025 * fpsr;
						//do { updscreen(); } while (freeze > timer);
					}
					
					if (joy[0].stick[a].axis[b].d2 && joy[0].stick[a].axis[b].pos != 0)
					{
						joyinfo[cur][0] = a;
						joyinfo[cur][1] = b;
						joyinfo[cur][2] = 2;
						
						//allegro_message("stick %d, axis %d\n%s\npos %d", a, b, joy[0].stick[a].axis[b].name, joy[0].stick[a].axis[b].pos);
						cur++;					
						freeze = timer + .025 * fpsr;
						//do { updscreen(); } while (freeze > timer);
						
					}
					
				}
			}
			for (a = 0; a < joy[0].num_buttons; a++)
			{
				
				if (joy[0].button[a].b && c == cur)
				{
					joyinfo[cur][0] = a;
					joyinfo[cur][1] = -1;

					cur++;
					freeze = timer + .025 * fpsr;
					//do { updscreen(); } while (freeze > timer);
				}				
			}
		}

		updscreen();

	} while (!key[KEY_ESC] && cur < k);

	if (cur == k) save_file_joypad();
}

void process_trigger()
{
	int p;
	char tmp[100];

	p = getpixel(triggerbmp, 24, 24);

	if (p > 999)
	{
		sprintf(tmp, "%d", (short)triggerinfo[p][0]);
		load_file_v1(tmp);	
		setup_scene();

		playerx = triggerinfo[p][1];
		playery = triggerinfo[p][2];
		playerz = triggerinfo[p][3];
	
		focusofs[0] = playerx;
		focusofs[1] = playery;
		focusofs[2] = playerz;

		fightfocus[0] = playerx;
		fightfocus[1] = playery;
		fightfocus[2] = playerz;
	}
}

void rotate_plane(int planenum)
{

	int	a;
	float	nx, ny, nz, x, y, z;

	for (a = 0; a <= planeinfo[planenum].lastpoint; a++)
	{
		x = planeinfo[planenum].pointinfo[a][0] - planeinfo[planenum].rbx;
		y = planeinfo[planenum].pointinfo[a][1] - planeinfo[planenum].rby;
		z = planeinfo[planenum].pointinfo[a][2] - planeinfo[planenum].rbz;

		rotpnt(x, y, z, planeinfo[planenum].xrot, planeinfo[planenum].yrot, planeinfo[planenum].zrot, &nx, &ny, &nz);

		planeinfo[planenum].pointinfo[a][3] = nx + planeinfo[planenum].rbx;
		planeinfo[planenum].pointinfo[a][4] = ny + planeinfo[planenum].rby;
		planeinfo[planenum].pointinfo[a][5] = nz + planeinfo[planenum].rbz;
	}

	calcsteps();
	setup_scene();

}
void setup_scene()
{	
	pointinfo.clear();
	polyinfo.clear();

	float nsx, nsy, nsz;

	int a, c, x, y, nx, ny, nz;

	point_t	tpoint;
	poly_t  tpoly;

	npolies = 0;
	npoints = 0;

	
	for (c = 0; c <= endplane; c++)
	{		
		if (planeinfo[c].active)
		{			
			planeinfo[c].npoints = 0;
			planeinfo[c].npolies = 0;

			for (a = 0; a <= planeinfo[c].lastpoint; a++)
			{
				if (planeinfo[c].pointinfo[a][7] == 0)
				{
					nsx = planeinfo[c].pointinfo[a][3] + planeinfo[c].basex;
					nsy = planeinfo[c].pointinfo[a][4] + planeinfo[c].basey;
					nsz = planeinfo[c].pointinfo[a][5] + planeinfo[c].basez;					

					nx = nsx;
					ny = nsy;
					nz = nsz;

					
					tpoint.nsx = nsx * prexx + nsy * preyx + nsz * prezx;
					tpoint.nsy = nsx * prexy + nsy * preyy + nsz * prezy;
					tpoint.nsz = nsx * prexz + nsy * preyz + nsz * prezz;
					tpoint.plane = c;
					tpoint.point = a;
					tpoint.xx = nsx;
					tpoint.yy = nsy;
					tpoint.ybase = nsy;
					tpoint.zz = nsz;
					tpoint.water = 0;

					planeinfo[c].pointinfo[a][6] = pointinfo.size();
					pointinfo.push_back(tpoint);					

					pointinfo[planeinfo[c].pointinfo[a][6]].active = FALSE;
					planeinfo[c].pointinfo[a][11] = 0;
									
					planeinfo[c].npoints++;	
					
					npoints++;

				}
			}

			for (a = 0; a <= planeinfo[c].lastpoly; a++)
			{				
				if (planeinfo[c].polyinfo[a][6] < 2)
				{
					tpoly.p1 = int(planeinfo[c].pointinfo[planeinfo[c].polyinfo[a][0]][6]);
					tpoly.p2 = int(planeinfo[c].pointinfo[planeinfo[c].polyinfo[a][1]][6]);
					tpoly.p3 = int(planeinfo[c].pointinfo[planeinfo[c].polyinfo[a][2]][6]);
					tpoly.tx = planeinfo[c].polyinfo[a][3];
					tpoly.u[0] = planeinfo[c].polyvtx[a][0];
					tpoly.v[0] = planeinfo[c].polyvtx[a][1];
					tpoly.u[1] = planeinfo[c].polyvtx[a][2];
					tpoly.v[1] = planeinfo[c].polyvtx[a][3];
					tpoly.u[2] = planeinfo[c].polyvtx[a][4];
					tpoly.v[2] = planeinfo[c].polyvtx[a][5];
					if (planeinfo[c].polyinfo[a][9] == 1)
					{
						pointinfo[tpoly.p1].water = 1;
						pointinfo[tpoly.p2].water = 1;
						pointinfo[tpoly.p3].water = 1;
					}
					if (planeinfo[c].polyinfo[a][9] == 2)
					{
						pointinfo[tpoly.p1].water = 2;
						pointinfo[tpoly.p2].water = 2;
						pointinfo[tpoly.p3].water = 2;
					}

					pointinfo[tpoly.p1].active = TRUE;
					pointinfo[tpoly.p2].active = TRUE;
					pointinfo[tpoly.p3].active = TRUE;
										
					tpoly.plane = c;
					tpoly.poly = a;
					tpoly.clipped = FALSE;
					if (planeinfo[c].polyinfo[a][7] == 1) tpoly.clipped = TRUE;
					tpoly.trigger = planeinfo[c].polyinfo[a][9];
					planeinfo[c].polyinfo[a][10] = 0;

									
					planeinfo[c].polyinfo[a][5] = polyinfo.size();
					if (planeinfo[c].radiosity_setup[a] == 0)
					{
						planeinfo[c].radiosity_setup[a] = 1;
						planeinfo[c].radiosity[a] = create_system_bitmap(16,16);						
					}
					if (planeinfo[c].radiosity_setup[a] == 1)
					{
						planeinfo[c].radiosity_setup[a] = 2;
						for (x = 0; x < 16; x++)
						{
							for (y = 0; y < 16; y++)
							{
								putpixel(planeinfo[c].radiosity[a], x, y, 0);
							}
						}						
						blit(textures[tpoly.tx], planeinfo[c].radiosity[a], 0, 0, 0, 0, 16, 16);
					}

					planeinfo[c].polyinfo[a][5] = polyinfo.size();
					polyinfo.push_back(tpoly);
					planeinfo[c].npolies++;
					npolies++;
				}
			}
			
		}
	}

}


void updphysics()
{
		
	focusofs[0] = focusofs[0] + (fightfocus[0] - focusofs[0]) * .09 * fpsr;
	focusofs[1] = focusofs[1] + (fightfocus[1] - focusofs[1]) * .09 * fpsr;
	focusofs[2] = focusofs[2] + (fightfocus[2] - focusofs[2]) * .09 * fpsr;
}
