/*
  Generation Olympia Engine - C++ Port
  Project Home: http://www.sourceforge.net/projects/qb2c/
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  $Id: goengine.cpp,v 1.6 2004/11/08 14:17:36 b_lindeijer Exp $
*/

#include "../engine/engineglobals.h"
#include "../engine/render.h"
#include "../engine/fileinput.h"

#include "gamefileinput.h"
#include "gameglobals.h"
#include "game.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


int main(void)
{
    	
	current_fade_level = 0.0;
	target_fade_level = 1.0;

    fpsr = 1;

	printf("Initializing game data...\n");
	initialize(24, 0, 640, 480);

	gameinit();

	updscreen();

	calcsteps();
	load_triggers_v1();
	
	load_file_v1("1");
	setup_scene();

	playerx = -4;
	playery = 0;
	playerz = 2;
	
	focusofs[0] = playerx;
	focusofs[1] = playery;
	focusofs[2] = playerz;

	fightfocus[0] = playerx;
	fightfocus[1] = playery;
	fightfocus[2] = playerz;

	camz = 66;
	camy = 3.5;
	camrx = 40;
	camry = 80;

	calcsteps();
	setup_scene();

	printf("Game data initialized, starting main loop...\n");	

	updphysics();

	vdist = viewdist;
	view_updated = FALSE;
	zm = 40;
	do
    {		
		poll_keyboard();		
		if (use_joy) poll_joystick();

		start = vdist;
		depth = 0;
				
		calcpoints();
		calcsprites();			

		sortpolys();

		checkkbd();

				
		drawpolys();
		drawhud();
				
	    process_trigger();
		updphysics();

		if (!view_updated) updscreen();
		
		//clear_to_color(offscreen, ambientc);
		clear_to_color(offscreen, 0);

		cycle = cycle + ripplewash * fpsr;		

		while (cycle > 16) { cycle = cycle - 16; }


		planeinfo[50].zrot = u(planeinfo[50].zrot + 4 * 4 * fpsr);

		rotate_plane(50);

	} while (!key[KEY_F12] && !key[KEY_ESC]);

	deinit();

	return 0;
}
END_OF_MAIN();
